gstreamermm 1.10.0

Public Types | Public Member Functions | List of all members
Gst::LibraryError Class Reference

The GStreamer library GError type. More...

`#include <gstreamermm/error.h>`

Inheritance diagram for Gst::LibraryError:
[legend]

## Public Types
enum | Code { FAILED = 1, TOO_LAZY, INIT, SHUTDOWN, SETTINGS, ENCODE, NUM_ERRORS }

## Public Member Functions
| LibraryError (Code error_code, const Glib::ustring& error_message)
| LibraryError (GError* gobject)
Code | code () const
Public Member Functions inherited from Glib::Error
| Error ()
| Error (GQuark error_domain, int error_code, const Glib::ustring &message)
| Error (GError *gobject, bool take_copy=false)
| Error (const Error &other)
Error & | operator= (const Error &other)
| ~Error () noexcept override
| operator bool () const
GQuark | domain () const
int | code () const
Glib::ustring | what () const override
bool | matches (GQuark error_domain, int error_code) const
GError * | gobj ()
const GError * | gobj () const
Public Member Functions inherited from Glib::Exception
virtual | ~Exception () noexcept=0

## Additional Inherited Members
Protected Attributes inherited from Glib::Error
GError * | gobject_

## Detailed Description

The GStreamer library GError type.

GStreamer elements can throw non-fatal warnings and fatal errors. Higher-level elements and applications can programatically filter the ones they are interested in or can recover from, and have a default handler handle the rest of them. Both warnings and fatal errors are treated similarly.

Library errors are for errors from the library being used by elements (initializing, finalizing, settings, ...)

- FAILED - a general error which doesn't fit in any other category. Make sure you add a custom message to the error call.
- TOO_LAZY - do not use this except as a placeholder for deciding where to go while developing code.
- INIT - used when the library could not be opened.
- SHUTDOWN - used when the library could not be closed.
- SETTINGS - used when the library doesn't accept settings.
- ENCODE - used when the library generated an encoding error.
- NUM_ERRORS - the number of library error types.

Elements do not have the context required to decide what to do with errors. As such, they should only inform about errors, and stop their processing. In short, an element doesn't know what it is being used for.

It is the application or compound element using the given element that has more context about the use of the element. Errors can be received by listening to the Gst::Bus of the element/pipeline for Gst::Message objects with the type Gst::MESSAGE_ERROR or Gst::MESSAGE_WARNING. The thrown errors should be inspected, and filtered if appropriate.

An application is expected to, by default, present the user with a dialog box (or an equivalent) showing the error message. The dialog should also allow a way to get at the additional debug information, so the user can provide bug reporting information.

A compound element is expected to forward errors by default higher up the hierarchy; this is done by default in the same way as for other types of Gst::Message.

When applications or compound elements trigger errors that they can recover from, they can filter out these errors and take appropriate action. For example, an application that gets an error from xvimagesink that indicates all XVideo ports are taken, the application can attempt to use another sink instead.

## Member Enumeration Documentation

## ◆ Code

enum Gst::LibraryError::Code

Library errors are for errors from the library being used by elements (initializing, finalizing, settings, ...)

Enumerator
FAILED | A general error which doesn't fit in any other category. Make sure you add a custom message to the error call.
TOO_LAZY | Do not use this except as a placeholder for deciding where to go while developing code.
INIT | Used when the library could not be opened.
SHUTDOWN | Used when the library could not be closed.
SETTINGS | Used when the library doesn't accept settings.
ENCODE | Used when the library generated an encoding error.
NUM_ERRORS | The number of library error types.

## Constructor & Destructor Documentation

## ◆ LibraryError() [1/2]

Gst::LibraryError::LibraryError | ( | Code | error_code,
|  | const Glib::ustring & | error_message
| ) |  |

## ◆ LibraryError() [2/2]

Gst::LibraryError::LibraryError | ( | GError * | gobject | ) |
| explicit

## Member Function Documentation

## ◆ code()

Code Gst::LibraryError::code | ( |  | ) | const